/*@ requires \valid_index(t,j) && \valid_index(t,i); 
  @ assigns t[i],t[j];
\
  @*/
void swap(int t[], int i, int j) {
  int tmp = t[i];
  t[i] = t[j];
  t[j] = tmp;
}

/*@ requires 0 <= p <= r && \valid_range(A,p,r);
  @ assigns A[p..r];
  @*/
int partition (int A[], int p, int r) 
{ 
  int x = A[r]; 
  int tmp, j, i = p-1; 
  /*@ loop invariant 
    @    p <= j <= r && p-1 <= i < j;
    @ loop variant (r-j);
    @*/
  for(j=p; j<r; j++) 
    if (A[j] <= x) { 
      i++;  
      swap(A,i,j);
    } 
  swap(A,i+1,r);
  return i+1; 
}

