/*@ requires \valid_index(t,j) && \valid_index(t,i); 
  @ assigns t[i],t[j];
  @ ensures t[i] == \old(t[j]) && t[j] == \old(t[i]);
  @*/
void swap(int t[], int i, int j, int p, int r) {
  int tmp = t[i];
  t[i] = t[j];
  t[j] = tmp;
}

/*@ requires 0 <= p <= r && \valid_range(A,p,r);
  @ assigns A[p..r];
  @ ensures  
  @      p <= \result <= r && 
  @      (\forall integer l; p <= l < \result ==> A[l] <= A[\result]) && 
  @      (\forall integer l; \result < l <= r ==> A[l] >  A[\result]) && 
  @      A[\result] == \old(A[r]) ;
  @*/
int partition (int A[], int p, int r) 
{ 
  int x = A[r]; 
  int tmp, j, i = p-1; 
  /*@ loop invariant 
    @    p <= j <= r && p-1 <= i < j && 
    @    (\forall integer k; (p <= k <= i) ==> A[k] <= x) &&
    @    (\forall integer k; (i <  k <  j) ==> A[k] >  x) &&
    @    A[r] == x; 
    @ loop variant (r-j);
    @*/
  for(j=p; j<r; j++) 
    if (A[j] <= x) { 
      i++;  
      swap(A,i,j,p,r);
    } 
  swap(A,i+1,r,p,r);
  return i+1; 
}

